class SerialRechargeList extends egret.gui.ItemRenderer
{
    public constructor()
    {
        super();

        this.skinName = "skins.ActivitieListSkin";

        this.touchChildren = true;

        this.touchEnabled = true;
    }

    public _weidacheng:egret.gui.UIAsset;

    public _btn_get:egret.gui.UIAsset;

    public _label_text:egret.gui.Label;

    public _icon1:UIIcon;

    public _icon3:UIIcon;

    public _icon2:UIIcon;

    public partAdded(partName:string, instance:any):void
    {
        super.partAdded(partName, instance);

        if(instance == this._btn_get)
        {
            this._btn_get.visible = false;

            this._btn_get.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onGet, this);
        }

        if(instance == this._weidacheng)
        {
            this._weidacheng.visible = false;
        }

        if(instance == this._icon1)
        {
            this._icon1.visible = false;
        }

        if(instance == this._icon3)
        {
            this._icon3.visible = false;
        }

        if(instance == this._icon2)
        {
            this._icon2.visible = false;
        }
    }

    private onGet(e:egret.TouchEvent):void
    {
        var url:string = "http://"+GameManager.server["ip"]+":"+GameManager.server["port"];

        var gift = this.data["gift"];

        var d:SerialRechargeDialog = DialogManager.findDialog(SerialRechargeDialog , "SerialRechargeDialog");

        if(d)
        {
            var param:string = "type=0x0137&sid="+GameManager.SESSION_ID + "&giftId=" + gift["giftId"] + "&activityType=" + d.obj["activityType"];

            HttpMessage.sendMsg(url, param);
        }
    }

    public dataChanged()
    {
        super.dataChanged();

        this._icon1.visible = false;
        this._icon2.visible = false;
        this._icon3.visible = false;

        if(this.data)
        {
            var day = this.data["day"];

            var state:number = Number(this.data["state"]);

            var itemList:Array<any> = this.data["itemList"];

            this._label_text.text = "连续充值" + day + "天可领取：";

            if(Number(state) == 0) //已经领取
            {
                this._weidacheng.source = "btn_txt_yijinglingqu";

                this._weidacheng.visible = true;

                this._btn_get.visible = false;
            }
            else if(Number(state) == 1) //可以领取
            {
                this._btn_get.visible = true;

                this._weidacheng.visible = false;
            }
            else if(Number(state) == 2)  //未达成
            {
                this._weidacheng.source = "weidachen";

                this._weidacheng.visible = true;

                this._btn_get.visible = false;
            }

            if(itemList && itemList.length > 0)
            {
                for(var i = 0; i<itemList.length; i++)
                {
                    var obj = itemList[i];

                    var maxType:number = Number(obj["itemType"]);

                    var itemId = obj["itemID"];

                    var num = obj["itemCount"];

                    var icon:UIIcon = this["_icon" + (i + 1)];

                    icon.visible = true;

                    if(Number(maxType) == 51)  //金币
                    {
                        icon.setCount(num + "");

                        icon.setName("金币");

                        icon.setItems("1");
                    }
                    else if(Number(maxType) == 52)  //元宝
                    {
                        icon.setCount(num + "");

                        icon.setName("元宝");

                        icon.setItems("2");
                    }
                    else if(Number(maxType) == 57)  //黑铁矿
                    {
                        icon.setCount(num + "");

                        icon.setName("黑铁矿石");

                        icon.setItems("3");
                    }
                    else
                    {
                        var item = GameManager.JSON_ITEM[itemId];

                        var items = {};

                        items["count"] = "" + num;

                        items["tpl"] = item;

                        icon.data = items;

                        icon.dataChanged();
                    }
                }
            }
        }
    }
}