class GameHint extends egret.gui.Group
{
    private m_UI:GameHintSkin;

    private time_id:number;

    public constructor()
    {
        super();

        super.createChildren();

        this.m_UI = new GameHintSkin();

        this.addElement(this.m_UI);

        this.m_UI.top = 0;

        this.m_UI.bottom = 0;

        this.m_UI.horizontalCenter = 0;

        this.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onTouch, this);
    }

    private onTouch(e:egret.TouchEvent):void
    {
        if(this.parent)
        {
            Main.guiLayer.removeElement(this);

            if(this.time_id) egret.clearTimeout(this.time_id);
        }
    }

    private onHide():void
    {
        this.onTouch(null);
    }

    public onShow(arr:Array<string>):void
    {
        if(arr && arr.length > 0)
        {
            var str:string = "";

            for(var i = 0; i < arr.length; i++)
            {
                str += "\n" + arr[i] + "\n";
            }

            if(i > 1)
            {
                this.height = 100 + (i * 33);
            }
            else
            {
                this.height = 100;
            }

            this.m_UI._labels.text = str;

            this.m_UI._labels.height = this.height - 15;
        }

        if(!this.parent)
        {
            Main.guiLayer.addElementAt(this, Main.guiLayer.numElements - 1);
        }

        this.verticalCenter = 0;

        this.horizontalCenter = 0;

        this.width = Main.guiLayer.width;

        this.m_UI.width = this.width;

        this.time_id = egret.setTimeout(this.onHide, this, 3000);
    }
}
