
class NewChatDialog extends Dialog
{
    private m_UI:NewChatUI;

    private txt_chat:egret.TextField = new egret.TextField();

    private txt_uiaseet:egret.gui.UIAsset;

    private textList:egret.gui.List = new egret.gui.List();

    private dp:egret.gui.ArrayCollection = new egret.gui.ArrayCollection();

    private textList_gh:egret.gui.List = new egret.gui.List();

    private dp_gh:egret.gui.ArrayCollection = new egret.gui.ArrayCollection();

    private isLimit:boolean = false;

    private lastSayTime:number = 0;     //0 1 2 4

    public chatP:number = 0;

    public constructor()
    {
        super();
    }

    public createChildren():void
    {
        super.createChildren();

        this.m_UI = new NewChatUI();

        this.addElement(this.m_UI);

        this.m_UI._btn_hh.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onHh, this);

        this.m_UI._btn_laba.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onLaba, this);

        this.m_UI._btn_send.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onSend, this);

        this.m_UI._btn_sj.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onSj, this);

        this.m_UI._btn_close.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onClose, this);

        this.m_UI._label_title.text = "世界聊天";

        this.horizontalCenter = 0;

        this.top = 30;

        this.textList.skinName = "skins.ListSkin";

        this.addElement(this.textList);

        this.textList.width = 578;

        this.textList.height = 570;

        this.textList.top = this.top + 40;

        this.textList.horizontalCenter = 0;

        this.textList.itemRenderer = new egret.gui.ClassFactory(ChatListUI);

        this.textList.itemRendererSkinName = "skins.ChatListSkin";

        this.textList.dataProvider = this.dp;

        this.textList.touchChildren = false;

        this.textList.touchEnabled = false;


        this.textList_gh.skinName = "skins.ListSkin";

        this.addElement(this.textList_gh);

        this.textList_gh.width = 578;

        this.textList_gh.height = 570;

        this.textList_gh.top = this.top + 40;

        this.textList_gh.horizontalCenter = 0;

        this.textList_gh.itemRenderer = new egret.gui.ClassFactory(ChatListUI);

        this.textList_gh.itemRendererSkinName = "skins.ChatListSkin";

        this.textList_gh.dataProvider = this.dp_gh;

        this.textList_gh.touchChildren = false;

        this.textList_gh.touchEnabled = false;

        this.txt_uiaseet = new egret.gui.UIAsset();

        this.txt_uiaseet.source = this.txt_chat;

        this.txt_chat.text = "";

        this.txt_chat.type = egret.TextFieldType.INPUT;

        this.txt_uiaseet.touchChildren = true;

        this.addElement(this.txt_uiaseet);


        this.txt_uiaseet.x = this.m_UI.x + 40;

        this.txt_uiaseet.y = 620;

        this.txt_chat.width = 434;

        this.txt_chat.height = 40;

        this.txt_chat.textColor = 0xffffff;

        this.txt_chat.size = 28;

        this.textList_gh.visible = false;
    }

    private onHh(e:egret.TouchEvent):void
    {
        this.textList.visible = false;
        this.textList_gh.visible = true;
        this.chatP = 1;
        this.m_UI._label_title.text = "行会聊天";
    }

    private onLaba(e:egret.TouchEvent):void
    {
        DialogManager.open(ChatHornDialog, "ChatHornDialog");
    }

    private checkMsg(str:string):boolean
    {
        if(this.isLimit)
        {
            this.addSysMsg("系统：您说的太快了!");
            return false;
        }

        if(!str){
            this.addSysMsg("系统：请输入聊天内容!");
            return false;
        }

        if(str.trim() == ""){
            this.addSysMsg("系统：请输入聊天内容!");
            return false;
        }

        if(str.length > 36)
        {
            this.addSysMsg("系统：您输入的字符超过36个!");
            return false;
        }

        if(str == "")
        {
            this.addSysMsg("系统：请输入聊天内容!");
            return false;
        }

        return true;
    }

    private onSend(e:egret.TouchEvent):void
    {
        if(!this.checkMsg(this.txt_chat.text)) return;

        var url:string = "http://"+GameManager.server["ip"]+":"+GameManager.server["port"];

        var param:string = "";
        if(this.chatP == 0)
        {
            param = "type=0x0048&sid="+GameManager.SESSION_ID + "&msg=" + this.txt_chat.text;
        }
        else if(this.chatP == 1)
        {
            param = "type=0x0140&sid=" + GameManager.SESSION_ID + "&msg=" + this.txt_chat.text;
        }

        HttpMessage.sendMsg(url, param);

        this.txt_chat.text = "";

        this.isLimit = true;

        this.lastSayTime = 3000;

        this.txt_chat.touchEnabled = false;
    }

    private onSj(e:egret.TouchEvent):void
    {
        this.textList.visible = true;
        this.textList_gh.visible = false;
        this.chatP = 0;
        this.m_UI._label_title.text = "世界聊天";
    }

    private onClose(e:egret.TouchEvent):void
    {
        this.hide();
    }

    public onUpdate():void
    {

    }

    public show()
    {
        super.show();
        this.onUpdate();

        Main.iconMeun.setSmallIconVis(false);
    }

    public hide()
    {
        super.hide();

        Main.iconMeun.setSmallIconVis(true);
    }

    public updateTime()
    {

        if(!this.isLimit) return;

        if(this.lastSayTime%1000 == 0)
        {
            this.txt_chat.text = Math.floor(this.lastSayTime/1000) + "s";

        }

        this.lastSayTime -= 100;

        if(this.lastSayTime <=0)
        {
            this.isLimit = false;
            this.txt_chat.text = "";
            this.txt_chat.touchEnabled = true;
        }
    }

    private cancelLimit():void
    {
        this.isLimit = false;
    }

    public addSysMsg(str:string):void
    {
        if(this.dp.length >=22)this.dp.removeItemAt(0);
        var msgTArr:Array<any> = [];
        msgTArr.push({text:str, style:{"textColor":0xff0000,"size":"20","fontFamily":"黑体"}});
        this.dp.addItem(msgTArr);
    }

    public addItems(obj:any, color:any = 0x461F23):void  ////arg:[{“id”,"order",“name”,"sex",“msg”},{}] id=聊天者id，order=聊天顺序，name=聊天人名字，sex=性别，msg=聊天内容
    {

        var str:string = "["+obj["name"]+"]说：" + obj["msg"];

        var len:number = str.length / 30;

        if(len > 1)
        {
            var start:number = 0;

            var i:number = 0;

            for(i = 0; i < len - 1; i++)
            {
                if(i > 0)
                {
                    start = i * 30 + 1;
                }
                else
                {
                    start = 0;
                }

                var h_str:string = str.substr(start, 30);

                if(this.dp.length >= 22) this.dp.removeItemAt(0);
                var msgTArr:Array<any> = [];
                msgTArr.push({text:h_str, style:{"textColor":color,"size":"20","fontFamily":"黑体"}});
                this.dp.addItem(msgTArr);
            }

            start = i * 30 + 1;

            var e_str:string = str.substr(start);

            if(this.dp.length >= 22) this.dp.removeItemAt(0);
            var msgTArr:Array<any> = [];
            msgTArr.push({text:e_str, style:{"textColor":color,"size":"20","fontFamily":"黑体"}});
            this.dp.addItem(msgTArr);
        }
        else
        {
            if(this.dp.length >= 22) this.dp.removeItemAt(0);
            var msgTArr:Array<any> = [];
            msgTArr.push({text:str, style:{"textColor":color,"size":"20","fontFamily":"黑体"}});
            this.dp.addItem(msgTArr);
        }
    }

    public addItemsHH(obj:any, color:any = 0x461F23):void
    {

        var str:string = "行会["+obj["name"]+"]说：" + obj["msg"];

        var len:number = str.length / 30;

        if(len > 1)
        {
            var start:number = 0;

            var i:number = 0;

            for(i = 0; i < len - 1; i++)
            {
                if(i > 0)
                {
                    start = i * 30 + 1;
                }
                else
                {
                    start = 0;
                }

                var h_str:string = str.substr(start, 30);

                if(this.dp_gh.length >= 22) this.dp_gh.removeItemAt(0);

                var msgTArr:Array<any> = [];
                msgTArr.push({text:h_str, style:{"textColor":color,"size":"20","fontFamily":"黑体"}});
                this.dp_gh.addItem(msgTArr);
            }

            start = i * 30 + 1;

            var e_str:string = str.substr(start);

            if(this.dp_gh.length >= 22) this.dp_gh.removeItemAt(0);
            var msgTArr:Array<any> = [];
            msgTArr.push({text:e_str, style:{"textColor":color,"size":"20","fontFamily":"黑体"}});
            this.dp_gh.addItem(msgTArr);
        }
        else
        {
            if(this.dp_gh.length >= 22) this.dp_gh.removeItemAt(0);
            var msgTArr:Array<any> = [];
            msgTArr.push({text:str, style:{"textColor":color,"size":"20","fontFamily":"黑体"}});
            this.dp_gh.addItem(msgTArr);
        }
    }
}
