
class TPlayerDialog extends Dialog
{
    private m_UI:TPlayerUI;

    private iconAny:any = {};

    public m_player:TPlayer;

    public constructor()
    {
        super();
    }

    public createChildren():void
    {
        super.createChildren();

        this.m_UI = new TPlayerUI();

        this.addElement(this.m_UI);

        for(var i = 1; i <= 10; i++)
        {
            var icon:UIIcon = this.m_UI["eqpt_icon_" + i];

            icon.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onClickIcon, this);

            icon.name = "" + i;

            this.iconAny[i] = icon;
        }

        this.m_UI.eqpt_hero.source = "hero_" + this.m_player.sex + "_" + this.m_player.job;

        this.horizontalCenter = 0;

        this.top = 30;

        this.m_UI._btn_close.addEventListener(egret.TouchEvent.TOUCH_TAP, this.onClose, this);

    }

    private onClose(e:egret.TouchEvent):void
    {
        this.hide();
    }

    private onClickIcon(e:egret.TouchEvent):void
    {

        var icon:UIIcon = e.currentTarget;

        if(icon.data)
        {
            Main.player.m_clickItme = icon.data;

            DialogManager.open(TPlayerDetails, "TPlayerDetails");
        }
    }

    public onUpdatePlayer():void
    {
        if(!this.initUI) return;

        this.m_UI._player_hp_label.text = this.m_player.hp +"/" +this.m_player.hpmax;

        this.m_UI._player_mp_label.text = this.m_player.mp +"/" +this.m_player.mpmax;

        //血条蓝条处理

        this.m_UI._title_hp.width = Math.floor(this.m_player.hp/this.m_player.hpmax>1?192:this.m_player.hp/this.m_player.hpmax*192);

        this.m_UI._title_mp.width = Math.floor(this.m_player.mp/this.m_player.mpmax>1?196:this.m_player.mp/this.m_player.mpmax*196);

        this.m_UI._label_baoji.text = "暴击：" + this.m_player.crit;

        this.m_UI._label_daoshugongji.text = "道术：" + this.m_player.tois;

        this.m_UI._label_heroname.text = "lv."+this.m_player.level+" " + this.m_player.name;

        this.m_UI._label_heroname.textColor = GameManager.getNameColor(this.m_player.pk);

        this.m_UI._label_mingzhong.text = "护甲：" + this.m_player.armor;  //护甲

        this.m_UI._label_mofafangyu.text = "魔法防御：" + this.m_player.mdef;

        this.m_UI._label_momagongji.text = "魔法：" + this.m_player.magic;

        this.m_UI._label_naili.text = "耐力：" + this.m_player.exer;

        this.m_UI._label_shanbi.text = "韧性：" + this.m_player.ten;  //韧性

        this.m_UI._label_shanghai.text = "伤害：" + this.m_player.hurtmin + "-" + this.m_player.hurtmax;

        this.m_UI._label_wulifangyu.text = "防御：" + this.m_player.def;

        this.m_UI._label_wuligongji.text = "攻击：" + this.m_player.atk;

        this.m_UI._label_zhandouli.text = "战力：" + this.m_player.fightvalue;

        this.m_UI._label_zhiye.text = "职业：" + GameManager.JOB_NAME[Number(this.m_player.job)];

        this.m_UI._hanghui_name.text = "" + this.m_player.faction;

        this.m_UI.eqpt_hero.source = "hero_" + this.m_player.sex + "_" + this.m_player.job;
    }

    public onUpdate():void
    {
        var hold:any = this.m_player.m_items.holdEq;
        for(var i in this.iconAny){
            var icon:UIIcon = this.iconAny[i];
            if(icon)
            {
                var equip:Equip = hold[i];

                if(equip)
                {
                    if(i > 2)
                    {
                        equip["effect"] = 1;

                        icon.setGroupSize();
                    }

                    icon.data = equip;

                    icon.dataChanged();

                    icon.setItems(equip.tpl["icon"]);

                    icon.setQuality(equip.qly);

                    icon.setName("Lv." + equip.tpl["lv"]);

                    icon._labels.text = GameManager.EQPT_TYPE[i];
                }
                else
                {
                    icon.setCount("");

                    icon.setItems("test_icon");

                    icon.setName("");

                    icon.setQuality(0);

                    icon.setText("");

                    icon.setStrength("");

                    icon.setEffVis();

                    icon._group.removeAllElements();

                    icon.data = null;
                }
                icon.setText(GameManager.EQPT_TYPE[i]);
            }
        }
    }

    public show()
    {
        super.show();

        this.onUpdate();

        this.onUpdatePlayer();
    }

    public hide()
    {
        super.hide();

        this.m_player = null;
    }
}
